#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <string.h>
#include <monetra.h>

#define mystreq(a,b) (strcasecmp(a,b)?0:1)

static int
not_here(char *s)
{
    croak("%s not implemented on this architecture", s);
    return -1;
}


static double
constant(char *name, int len, int arg)
{
    errno=0;
    if (mystreq(name, "MC_TRANTYPE")) {
      return(MC_TRANTYPE);
    } else if (mystreq(name, "MC_USERNAME")) {
      return(MC_USERNAME);
    } else if (mystreq(name, "MC_PASSWORD")) {
      return(MC_PASSWORD);
    } else if (mystreq(name, "MC_ACCOUNT")) {
      return(MC_ACCOUNT);
    } else if (mystreq(name, "MC_TRACKDATA")) {
      return(MC_TRACKDATA);
    } else if (mystreq(name, "MC_EXPDATE")) {
      return(MC_EXPDATE);
    } else if (mystreq(name, "MC_STREET")) {
      return(MC_STREET);
    } else if (mystreq(name, "MC_ZIP")) {
      return(MC_ZIP);
    } else if (mystreq(name, "MC_CV")) {
      return(MC_CV);
    } else if (mystreq(name, "MC_COMMENTS")) {
      return(MC_COMMENTS);
    } else if (mystreq(name, "MC_CLERKID")) {
      return(MC_CLERKID);
    } else if (mystreq(name, "MC_STATIONID")) {
      return(MC_STATIONID);
    } else if (mystreq(name, "MC_APPRCODE")) {
      return(MC_APPRCODE);
    } else if (mystreq(name, "MC_AMOUNT")) {
      return(MC_AMOUNT);
    } else if (mystreq(name, "MC_PTRANNUM")) {
      return(MC_PTRANNUM);
    } else if (mystreq(name, "MC_TTID")) {
      return(MC_TTID);
    } else if (mystreq(name, "MC_USER")) {
      return(MC_USER);
    } else if (mystreq(name, "MC_PWD")) {
      return(MC_PWD);
    } else if (mystreq(name, "MC_ACCT")) {
      return(MC_ACCT);
    } else if (mystreq(name, "MC_BDATE")) {
      return(MC_BDATE);
    } else if (mystreq(name, "MC_EDATE")) {
      return(MC_EDATE);
    } else if (mystreq(name, "MC_BATCH")) {
      return(MC_BATCH);
    } else if (mystreq(name, "MC_FILE")) {
      return(MC_FILE);
    } else if (mystreq(name, "MC_ADMIN")) {
      return(MC_ADMIN);
    } else if (mystreq(name, "MC_AUDITTYPE")) {
      return(MC_AUDITTYPE);
    } else if (mystreq(name, "MC_CUSTOM")) {
      return(MC_CUSTOM);
    } else if (mystreq(name, "MC_USER_PROC")) {
      return(MC_USER_PROC);
    } else if (mystreq(name, "MC_USER_USER")) {
      return(MC_USER_USER);
    } else if (mystreq(name, "MC_USER_PWD")) {
      return(MC_USER_PWD);
    } else if (mystreq(name, "MC_USER_INDCODE")) {
      return(MC_USER_INDCODE);
    } else if (mystreq(name, "MC_USER_MERCHID")) {
      return(MC_USER_MERCHID);
    } else if (mystreq(name, "MC_USER_BANKID")) {
      return(MC_USER_BANKID);
    } else if (mystreq(name, "MC_USER_TERMID")) {
      return(MC_USER_TERMID);
    } else if (mystreq(name, "MC_USER_CLIENTNUM")) {
      return(MC_USER_CLIENTNUM);
    } else if (mystreq(name, "MC_USER_STOREID")) {
      return(MC_USER_STOREID);
    } else if (mystreq(name, "MC_USER_AGENTID")) {
      return(MC_USER_AGENTID);
    } else if (mystreq(name, "MC_USER_CHAINID")) {
      return(MC_USER_CHAINID);
    } else if (mystreq(name, "MC_USER_ZIPCODE")) {
      return(MC_USER_ZIPCODE);
    } else if (mystreq(name, "MC_USER_TIMEZONE")) {
      return(MC_USER_TIMEZONE);
    } else if (mystreq(name, "MC_USER_MERCHCAT")) {
      return(MC_USER_MERCHCAT);
    } else if (mystreq(name, "MC_USER_MERNAME")) {
      return(MC_USER_MERNAME);
    } else if (mystreq(name, "MC_USER_MERCHLOC")) {
      return(MC_USER_MERCHLOC);
    } else if (mystreq(name, "MC_USER_STATECODE")) {
      return(MC_USER_STATECODE);
    } else if (mystreq(name, "MC_USER_PHONE")) {
      return(MC_USER_PHONE);
    } else if (mystreq(name, "MC_TRAN_SALE")) {
      return(MC_TRAN_SALE);
    } else if (mystreq(name, "MC_TRAN_PREAUTH")) {
      return(MC_TRAN_PREAUTH);
    } else if (mystreq(name, "MC_TRAN_VOID")) {
      return(MC_TRAN_VOID);
    } else if (mystreq(name, "MC_TRAN_PREAUTHCOMPLETE")) {
      return(MC_TRAN_PREAUTHCOMPLETE);
    } else if (mystreq(name, "MC_TRAN_FORCE")) {
      return(MC_TRAN_FORCE);
    } else if (mystreq(name, "MC_TRAN_OVERRIDE")) {
      return(MC_TRAN_OVERRIDE);
    } else if (mystreq(name, "MC_TRAN_RETURN")) {
      return(MC_TRAN_RETURN);
    } else if (mystreq(name, "MC_TRAN_SETTLE")) {
      return(MC_TRAN_SETTLE);
    } else if (mystreq(name, "MC_TRAN_ADMIN")) {
      return(MC_TRAN_ADMIN);
    } else if (mystreq(name, "MC_TRAN_PING")) {
      return(MC_TRAN_PING);
    } else if (mystreq(name, "MC_TRAN_CHKPWD")) {
      return(MC_TRAN_CHKPWD);
    } else if (mystreq(name, "MC_TRAN_CHNGPWD")) {
      return(MC_TRAN_CHNGPWD);
    } else if (mystreq(name, "MC_TRAN_LISTSTATS")) {
      return(MC_TRAN_LISTSTATS);
    } else if (mystreq(name, "MC_TRAN_LISTUSERS")) {
      return(MC_TRAN_LISTUSERS);
    } else if (mystreq(name, "MC_TRAN_GETUSERINFO")) {
      return(MC_TRAN_GETUSERINFO);
    } else if (mystreq(name, "MC_TRAN_ADDUSER")) {
      return(MC_TRAN_ADDUSER);
    } else if (mystreq(name, "MC_TRAN_EDITUSER")) {
      return(MC_TRAN_EDITUSER);
    } else if (mystreq(name, "MC_TRAN_DELUSER")) {
      return(MC_TRAN_DELUSER);
    } else if (mystreq(name, "MC_TRAN_ENABLEUSER")) {
      return(MC_TRAN_ENABLEUSER);
    } else if (mystreq(name, "MC_TRAN_DISABLEUSER")) {
      return(MC_TRAN_DISABLEUSER);
    } else if (mystreq(name, "MC_TRAN_IMPORT")) {
      return(MC_TRAN_IMPORT);
    } else if (mystreq(name, "MC_TRAN_EXPORT")) {
      return(MC_TRAN_EXPORT);
    } else if (mystreq(name, "MC_ADMIN_GUT")) {
      return(MC_ADMIN_GUT);
    } else if (mystreq(name, "MC_ADMIN_GL")) {
      return(MC_ADMIN_GL);
    } else if (mystreq(name, "MC_ADMIN_GFT")) {
      return(MC_ADMIN_GFT);
    } else if (mystreq(name, "MC_ADMIN_BT")) {
      return(MC_ADMIN_BT);
    } else if (mystreq(name, "MC_ADMIN_UB")) {
      return(MC_ADMIN_UB);
    } else if (mystreq(name, "MC_ADMIN_QC")) {
      return(MC_ADMIN_QC);
    } else if (mystreq(name, "MC_ADMIN_RS")) {
      return(MC_ADMIN_RS);
    } else if (mystreq(name, "MC_ADMIN_CTH")) {
      return(MC_ADMIN_CTH);
    } else if (mystreq(name, "MC_ADMIN_CFH")) {
      return(MC_ADMIN_CFH);
    } else if (mystreq(name, "MC_ADMIN_FORCESETTLE")) {
      return(MC_ADMIN_FORCESETTLE);
    } else if (mystreq(name, "MC_ADMIN_SETBATCHNUM")) {
      return(MC_ADMIN_SETBATCHNUM);
    } else if (mystreq(name, "M_UNUSED")) {
      return(M_UNUSED);
    } else if (mystreq(name, "M_NEW")) {
      return(M_NEW);
    } else if (mystreq(name, "M_PENDING")) {
      return(M_PENDING);
    } else if (mystreq(name, "M_DONE")) {
      return(M_DONE);
    } else if (mystreq(name, "M_ERROR")) {
      return(M_ERROR);
    } else if (mystreq(name, "M_FAIL")) {
      return(M_FAIL);
    } else if (mystreq(name, "M_SUCCESS")) {
      return(M_SUCCESS);
    } else if (mystreq(name, "M_AUTH")) {
      return(M_AUTH);
    } else if (mystreq(name, "M_DENY")) {
      return(M_DENY);
    } else if (mystreq(name, "M_CALL")) {
      return(M_CALL);
    } else if (mystreq(name, "M_DUPL")) {
      return(M_DUPL);
    } else if (mystreq(name, "M_PKUP")) {
      return(M_PKUP);
    } else if (mystreq(name, "M_RETRY")) {
      return(M_RETRY);
    } else if (mystreq(name, "M_TIMEOUT")) {
      return(M_TIMEOUT);
    } else if (mystreq(name, "M_GOOD")) {
      return(M_GOOD);
    } else if (mystreq(name, "M_BAD")) {
      return(M_BAD);
    } else if (mystreq(name, "M_STREET")) {
      return(M_STREET);
    } else if (mystreq(name, "M_ZIP")) {
      return(M_ZIP);
    } else if (mystreq(name, "M_UNKNOWN")) {
      return(M_UNKNOWN);
    } else if (mystreq(name, "M_SALE")) {
      return(M_SALE);
    } else if (mystreq(name, "M_PREAUTH")) {
      return(M_PREAUTH);
    } else if (mystreq(name, "M_FORCE")) {
      return(M_FORCE);
    } else if (mystreq(name, "M_OVERRIDE")) {
      return(M_OVERRIDE);
    } else if (mystreq(name, "M_RETURN")) {
      return(M_RETURN);
    } else if (mystreq(name, "M_VOID")) {
      return(M_VOID);
    } else if (mystreq(name, "M_SETTLE")) {
      return(M_SETTLE);
    } else if (mystreq(name, "M_PROC")) {
      return(M_PROC);
    } else if (mystreq(name, "M_USER")) {
      return(M_USER);
    } else if (mystreq(name, "M_PWD")) {
      return(M_PWD);
    } else if (mystreq(name, "M_INDCODE")) {
      return(M_INDCODE);
    } else if (mystreq(name, "M_MERCHID")) {
      return(M_MERCHID);
    } else if (mystreq(name, "M_BANKID")) {
      return(M_BANKID);
    } else if (mystreq(name, "M_TERMID")) {
      return(M_TERMID);
    } else if (mystreq(name, "M_CLIENTNUM")) {
      return(M_CLIENTNUM);
    } else if (mystreq(name, "M_STOREID")) {
      return(M_STOREID);
    } else if (mystreq(name, "M_AGENTID")) {
      return(M_AGENTID);
    } else if (mystreq(name, "M_CHAINID")) {
      return(M_CHAINID);
    } else if (mystreq(name, "M_ZIPCODE")) {
      return(M_ZIPCODE);
    } else if (mystreq(name, "M_TIMEZONE")) {
      return(M_TIMEZONE);
    } else if (mystreq(name, "M_MERCHCAT")) {
      return(M_MERCHCAT);
    } else if (mystreq(name, "M_MERNAME")) {
      return(M_MERNAME);
    } else if (mystreq(name, "M_MERCHLOC")) {
      return(M_MERCHLOC);
    } else if (mystreq(name, "M_STATECODE")) {
      return(M_STATECODE);
    } else if (mystreq(name, "M_SERVICEPHONE")) {
      return(M_SERVICEPHONE);
    
    } else if (mystreq(name, "MCVE_UNUSED")) {
      return(M_UNUSED);
    } else if (mystreq(name, "MCVE_NEW")) {
      return(M_NEW);
    } else if (mystreq(name, "MCVE_PENDING")) {
      return(M_PENDING);
    } else if (mystreq(name, "MCVE_DONE")) {
      return(M_DONE);
    } else if (mystreq(name, "MCVE_ERROR")) {
      return(M_ERROR);
    } else if (mystreq(name, "MCVE_FAIL")) {
      return(M_FAIL);
    } else if (mystreq(name, "MCVE_SUCCESS")) {
      return(M_SUCCESS);
    } else if (mystreq(name, "MCVE_AUTH")) {
      return(M_AUTH);
    } else if (mystreq(name, "MCVE_DENY")) {
      return(M_DENY);
    } else if (mystreq(name, "MCVE_CALL")) {
      return(M_CALL);
    } else if (mystreq(name, "MCVE_DUPL")) {
      return(M_DUPL);
    } else if (mystreq(name, "MCVE_PKUP")) {
      return(M_PKUP);
    } else if (mystreq(name, "MCVE_RETRY")) {
      return(M_RETRY);
    } else if (mystreq(name, "MCVE_TIMEOUT")) {
      return(M_TIMEOUT);
    } else if (mystreq(name, "MCVE_GOOD")) {
      return(M_GOOD);
    } else if (mystreq(name, "MCVE_BAD")) {
      return(M_BAD);
    } else if (mystreq(name, "MCVE_STREET")) {
      return(M_STREET);
    } else if (mystreq(name, "MCVE_ZIP")) {
      return(M_ZIP);
    } else if (mystreq(name, "MCVE_UNKNOWN")) {
      return(M_UNKNOWN);
    } else if (mystreq(name, "MCVE_SALE")) {
      return(M_SALE);
    } else if (mystreq(name, "MCVE_PREAUTH")) {
      return(M_PREAUTH);
    } else if (mystreq(name, "MCVE_FORCE")) {
      return(M_FORCE);
    } else if (mystreq(name, "MCVE_OVERRIDE")) {
      return(M_OVERRIDE);
    } else if (mystreq(name, "MCVE_RETURN")) {
      return(M_RETURN);
    } else if (mystreq(name, "MCVE_VOID")) {
      return(M_VOID);
    } else if (mystreq(name, "MCVE_SETTLE")) {
      return(M_SETTLE);
    } else if (mystreq(name, "MCVE_PROC")) {
      return(M_PROC);
    } else if (mystreq(name, "MCVE_USER")) {
      return(M_USER);
    } else if (mystreq(name, "MCVE_PWD")) {
      return(M_PWD);
    } else if (mystreq(name, "MCVE_INDCODE")) {
      return(M_INDCODE);
    } else if (mystreq(name, "MCVE_MERCHID")) {
      return(M_MERCHID);
    } else if (mystreq(name, "MCVE_BANKID")) {
      return(M_BANKID);
    } else if (mystreq(name, "MCVE_TERMID")) {
      return(M_TERMID);
    } else if (mystreq(name, "MCVE_CLIENTNUM")) {
      return(M_CLIENTNUM);
    } else if (mystreq(name, "MCVE_STOREID")) {
      return(M_STOREID);
    } else if (mystreq(name, "MCVE_AGENTID")) {
      return(M_AGENTID);
    } else if (mystreq(name, "MCVE_CHAINID")) {
      return(M_CHAINID);
    } else if (mystreq(name, "MCVE_ZIPCODE")) {
      return(M_ZIPCODE);
    } else if (mystreq(name, "MCVE_TIMEZONE")) {
      return(M_TIMEZONE);
    } else if (mystreq(name, "MCVE_MERCHCAT")) {
      return(M_MERCHCAT);
    } else if (mystreq(name, "MCVE_MERNAME")) {
      return(M_MERNAME);
    } else if (mystreq(name, "MCVE_MERCHLOC")) {
      return(M_MERCHLOC);
    } else if (mystreq(name, "MCVE_STATECODE")) {
      return(M_STATECODE);
    } else if (mystreq(name, "MCVE_SERVICEPHONE")) {
      return(M_SERVICEPHONE);
    } else {
      errno = ENOENT;
      return(0);
    }
  return(0);
}



MODULE = Monetra		PACKAGE = Monetra


double
constant(sv,arg)
    PREINIT:
	STRLEN		len;
    INPUT:
	SV *		sv
	char *		s = SvPV(sv, len);
	int		arg
    CODE:
	RETVAL = constant(s,len,arg);
    OUTPUT:
	RETVAL


int
M_CheckStatus(myconn, trans)
	M_CONN *	myconn
	IV	trans

int
MCVE_CheckStatus(myconn, trans)
	M_CONN *	myconn
	IV	trans

AV *
M_CompleteAuthorizations(myconn)
	M_CONN *	myconn
	PREINIT:
		AV * av;
		int num_ret = 0;
		int i;
		long *	listings;
	CODE:
		av = (AV *)sv_2mortal((SV *)newAV());

		num_ret = M_CompleteAuthorizations(myconn, &listings);
		for (i=0; i<num_ret; i++) {
			printf("list: %ld\r\n", listings[i]);
			av_push(av, newSViv(listings[i]));
		}
		free(listings);

		RETVAL = av;
	OUTPUT:
		RETVAL

AV *
MCVE_CompleteAuthorizations(myconn)
	M_CONN *	myconn
	PREINIT:
		AV * av;
		int num_ret = 0;
		int i;
		long *	listings;
	CODE:
		av = (AV *)sv_2mortal((SV *)newAV());

		num_ret = M_CompleteAuthorizations(myconn, &listings);
		for (i=0; i<num_ret; i++) {
			printf("list: %ld\r\n", listings[i]);
			av_push(av, newSViv(listings[i]));
		}
		free(listings);

		RETVAL = av;
	OUTPUT:
		RETVAL

int
M_Connect(myconn)
	M_CONN *	myconn

int
MCVE_Connect(myconn)
	M_CONN *	myconn

const char *
M_ConnectionError(myconn)
	M_CONN *	myconn

const char *
MCVE_ConnectionError(myconn)
	M_CONN *	myconn

void
M_DeleteTrans(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

void
MCVE_DeleteTrans(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

void
M_DeleteResponse(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

void
MCVE_DeleteResponse(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

void
M_DestroyConn(myconn)
	M_CONN *	myconn
	CODE:
		M_DestroyConn(myconn);
		free(myconn);

void
MCVE_DestroyConn(myconn)
	M_CONN *	myconn
	CODE:
		M_DestroyConn(myconn);
		free(myconn);

void
M_DestroyEngine()

void
MCVE_DestroyEngine()


const char *
M_GetCell(myconn, identifier, column, row)
	M_CONN *	myconn
	IV	identifier
	const char *	column
	long	row

const char *
MCVE_GetCell(myconn, identifier, column, row)
	M_CONN *	myconn
	IV	identifier
	const char *	column
	long	row

const char *
M_GetCellByNum(myconn, identifier, column, row)
	M_CONN *	myconn
	IV	identifier
	int	column
	long	row

const char *
MCVE_GetCellByNum(myconn, identifier, column, row)
	M_CONN *	myconn
	IV	identifier
	int	column
	long	row

const char *
M_GetCommaDelimited(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

const char *
MCVE_GetCommaDelimited(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

const char *
M_GetHeader(myconn, identifier, column_num)
	M_CONN *	myconn
	IV	identifier
	int	column_num

const char *
MCVE_GetHeader(myconn, identifier, column_num)
	M_CONN *	myconn
	IV	identifier
	int	column_num

M_CONN *
M_InitConn()
	PREINIT:
	M_CONN *conn;
	CODE:
		conn=(M_CONN *)malloc(sizeof(M_CONN));
		M_InitConn(conn);
		M_ValidateIdentifier(conn, 1);
		RETVAL = conn;
	OUTPUT:
		RETVAL

M_CONN *
MCVE_InitConn()
	PREINIT:
	M_CONN *conn;
	CODE:
		conn=(M_CONN *)malloc(sizeof(M_CONN));
		M_InitConn(conn);
		M_ValidateIdentifier(conn, 1);
		RETVAL = conn;
	OUTPUT:
		RETVAL

int
M_InitEngine(location)
	const char *	location

int
MCVE_InitEngine(location)
	const char *	location

int
M_IsCommaDelimited(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

int
MCVE_IsCommaDelimited(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

void
M_MaxConnTimeout(myconn, maxtime)
	M_CONN *	myconn
	int	maxtime

void
MCVE_MaxConnTimeout(myconn, maxtime)
	M_CONN *	myconn
	int	maxtime

int
M_Monitor(myconn)
	M_CONN *	myconn

int
MCVE_Monitor(myconn)
	M_CONN *	myconn

int
M_NumColumns(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

int
MCVE_NumColumns(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

long
M_NumRows(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

long
MCVE_NumRows(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

int
M_ParseCommaDelimited(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

int
MCVE_ParseCommaDelimited(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

AV *
M_ResponseKeys(myconn, identifier)
	M_CONN *	myconn
	IV	identifier
	PREINIT:
		AV * av;
		int num_ret = 0;
		int i;
		char **	myret;
	CODE:
		av = (AV *)sv_2mortal((SV *)newAV());
		myret = M_ResponseKeys(myconn, identifier, &num_ret);
		for (i=0; i<num_ret; i++) {
			av_push(av, newSVpv(myret[i], 0));
		}
		M_FreeResponseKeys(myret, num_ret);

		RETVAL = av;
	OUTPUT:
		RETVAL

AV *
MCVE_ResponseKeys(myconn, identifier)
	M_CONN *	myconn
	IV	identifier
	PREINIT:
		AV * av;
		int num_ret = 0;
		int i;
		char **	myret;
	CODE:
		av = (AV *)sv_2mortal((SV *)newAV());
		myret = M_ResponseKeys(myconn, identifier, &num_ret);
		for (i=0; i<num_ret; i++) {
			av_push(av, newSVpv(myret[i], 0));
		}
		M_FreeResponseKeys(myret, num_ret);

		RETVAL = av;
	OUTPUT:
		RETVAL


const char *
M_ResponseParam(myconn, identifier, key)
	M_CONN *	myconn
	IV	identifier
	const char *	key

const char *
MCVE_ResponseParam(myconn, identifier, key)
	M_CONN *	myconn
	IV	identifier
	const char *	key

int
M_ReturnCode(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

int
MCVE_ReturnCode(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

int
M_ReturnStatus(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

int
MCVE_ReturnStatus(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

int
M_SetBlocking(myconn, tf)
	M_CONN *	myconn
	int	tf

int
MCVE_SetBlocking(myconn, tf)
	M_CONN *	myconn
	int	tf

int
M_SetDropFile(myconn, df_location)
	M_CONN *	myconn
	const char *	df_location

int
MCVE_SetDropFile(myconn, df_location)
	M_CONN *	myconn
	const char *	df_location

int
M_SetIP(myconn, host, port)
	M_CONN *	myconn
	const char *	host
	unsigned long	port

int
MCVE_SetIP(myconn, host, port)
	M_CONN *	myconn
	const char *	host
	unsigned long	port

int
M_SetLogging(myconn, level)
	M_CONN *	myconn
	int		level

int
MCVE_SetLogging(myconn, level)
	M_CONN *	myconn
	int		level
	CODE:
		RETVAL=M_SetLogging(myconn, level);
	OUTPUT:
		RETVAL

int
M_SetSSL(myconn, host, port)
	M_CONN *	myconn
	const char *	host
	unsigned long	port

int
MCVE_SetSSL(myconn, host, port)
	M_CONN *	myconn
	const char *	host
	unsigned long	port

int
M_SetSSL_CAfile(myconn, path)
	M_CONN *	myconn
	const char *	path

int
MCVE_SetSSL_CAfile(myconn, path)
	M_CONN *	myconn
	const char *	path

int
M_SetSSL_Files(myconn, sslkeyfile, sslcertfile)
	M_CONN *	myconn
	const char *	sslkeyfile
	const char *	sslcertfile

int
MCVE_SetSSL_Files(myconn, sslkeyfile, sslcertfile)
	M_CONN *	myconn
	const char *	sslkeyfile
	const char *	sslcertfile

int
M_SetTimeout(myconn, timeout)
	M_CONN *	myconn
	long	timeout

int
MCVE_SetTimeout(myconn, timeout)
	M_CONN *	myconn
	long	timeout

char *
M_SSLCert_gen_hash(filename)
	const char *	filename
	PREINIT:
		char *tempfile = NULL;
	CODE:
		tempfile = M_SSLCert_gen_hash(filename);
		if (tempfile != NULL) {
			New(0, RETVAL, strlen(tempfile), char);
			strncpy(RETVAL, tempfile, strlen(tempfile));
			free(tempfile);
		} else {
			RETVAL=NULL;
		}
	OUTPUT:
		RETVAL
	CLEANUP:
		Safefree(RETVAL);

char *
MCVE_SSLCert_gen_hash(filename)
	const char *	filename
	PREINIT:
		char *tempfile = NULL;
	CODE:
		tempfile = M_SSLCert_gen_hash(filename);
		if (tempfile != NULL) {
			New(0, RETVAL, strlen(tempfile), char);
			strncpy(RETVAL, tempfile, strlen(tempfile));
			free(tempfile);
		} else {
			RETVAL=NULL;
		}
	OUTPUT:
		RETVAL
	CLEANUP:
		Safefree(RETVAL);

const char *
M_TEXT_AVS(code)
	int	code

const char *
MCVE_TEXT_AVS(code)
	int	code

const char *
M_TEXT_CV(code)
	int	code

const char *
MCVE_TEXT_CV(code)
	int	code

const char *
M_TEXT_Code(code)
	int	code

const char *
MCVE_TEXT_Code(code)
	int	code

long
M_TransInQueue(myconn)
	M_CONN *	myconn

long
MCVE_TransInQueue(myconn)
	M_CONN *	myconn

IV
M_TransNew(myconn)
	M_CONN *	myconn

IV
MCVE_TransNew(myconn)
	M_CONN *	myconn


int
M_TransParam(myconn, identifier, key, ...)
	M_CONN *	myconn
	IV	identifier
	int	key
    PREINIT:
	STRLEN n_a;
    CODE:
      if (items > 3) {
        switch (key) {
	  case MC_TRANTYPE:
	  case MC_PTRANNUM:
	  case MC_TTID:
	  case MC_ADMIN:
	  case MC_AUDITTYPE:
	    RETVAL = M_TransParam(myconn, (M_uintptr)identifier, key, (int)SvIV(ST(3)));
	  break;
	  
	  case MC_AMOUNT:
	    RETVAL = M_TransParam(myconn, (M_uintptr)identifier, key, (double)SvNV(ST(3)));
	  break;

	  case MC_CUSTOM:
	    RETVAL = M_TransParam(myconn, (M_uintptr)identifier, key, (char *)SvPV(ST(3), n_a), (char *)SvPV(ST(4), n_a));
	  break;

	  default:
	    RETVAL = M_TransParam(myconn, (M_uintptr)identifier, key, (char *)SvPV(ST(3), n_a));
          break;
	}
      } else {
        RETVAL = 0;
      }
    OUTPUT:
	RETVAL

int
MCVE_TransParam(myconn, identifier, key, ...)
	M_CONN *	myconn
	IV	identifier
	int	key
    PREINIT:
	STRLEN n_a;
    CODE:
      if (items > 3) {
        switch (key) {
	  case MC_TRANTYPE:
	  case MC_PTRANNUM:
	  case MC_TTID:
	  case MC_ADMIN:
	  case MC_AUDITTYPE:
	    RETVAL = M_TransParam(myconn, (M_uintptr)identifier, key, (int)SvIV(ST(3)));
	  break;
	  
	  case MC_AMOUNT:
	    RETVAL = M_TransParam(myconn, (M_uintptr)identifier, key, (double)SvNV(ST(3)));
	  break;

	  case MC_CUSTOM:
	    RETVAL = M_TransParam(myconn, (M_uintptr)identifier, key, (char *)SvPV(ST(3), n_a), (char *)SvPV(ST(4), n_a));
	  break;

	  default:
	    RETVAL = M_TransParam(myconn, (M_uintptr)identifier, key, (char *)SvPV(ST(3), n_a));
          break;
	}
      } else {
        RETVAL = 0;
      }
    OUTPUT:
	RETVAL


int
M_TransKeyVal(myconn, identifier, key, val)
	M_CONN *	myconn
	IV	identifier
	const char *	key
	const char *	val

int
MCVE_TransKeyVal(myconn, identifier, key, val)
	M_CONN *	myconn
	IV	identifier
	const char *	key
	const char *	val
	CODE:
		RETVAL=M_TransKeyVal(myconn, identifier, key, val);
	OUTPUT:
		RETVAL

int
M_TransSend(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

int
MCVE_TransSend(myconn, identifier)
	M_CONN *	myconn
	IV	identifier


int
M_TransactionAVS(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

int
MCVE_TransactionAVS(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

const char *
M_TransactionAuth(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

const char *
MCVE_TransactionAuth(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

long
M_TransactionBatch(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

long
MCVE_TransactionBatch(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

int
M_TransactionCV(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

int
MCVE_TransactionCV(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

IV
M_TransactionID(myconn, identifier)
	M_CONN *	myconn
	IV	identifier
	CODE:
	  RETVAL = M_TransactionID(myconn, identifier);
	OUTPUT:
	  RETVAL

IV
MCVE_TransactionID(myconn, identifier)
	M_CONN *	myconn
	IV	identifier
	CODE:
	  RETVAL = M_TransactionID(myconn, identifier);
	OUTPUT:
	  RETVAL

long
M_TransactionItem(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

long
MCVE_TransactionItem(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

const char *
M_TransactionText(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

const char *
MCVE_TransactionText(myconn, identifier)
	M_CONN *	myconn
	IV	identifier

int
M_TransactionsSent(myconn)
	M_CONN *	myconn

int
MCVE_TransactionsSent(myconn)
	M_CONN *	myconn

int
M_ValidateIdentifier(myconn, tf)
	M_CONN *	myconn
	int		tf

int
MCVE_ValidateIdentifier(myconn, tf)
	M_CONN *	myconn
	int		tf
	CODE:
		RETVAL=M_ValidateIdentifier(myconn, tf);
	OUTPUT:
		RETVAL


void
M_VerifyConnection(myconn, tf)
	M_CONN *	myconn
	int	tf

void
MCVE_VerifyConnection(myconn, tf)
	M_CONN *	myconn
	int	tf

void
M_VerifySSLCert(myconn, tf)
	M_CONN *	myconn
	int	tf

void
MCVE_VerifySSLCert(myconn, tf)
	M_CONN *	myconn
	int	tf

int
M_uwait(length)
	unsigned long	length

int
MCVE_uwait(length)
	unsigned long	length
